#ifndef cm3_mutex_types_H
#define cm3_mutex_types_H

/*{ cm3_mutex.h ***********************************************
 * 
 * Written by Gregor Rebel 2010-2012
 *
 * Low-level datatypes for Mutual Exclusive Locks (Mutexes) on Cortex M3 architecture.
 * 
}*/

//{ includes

#include "ttc_basic.h"

//}includes

// datatype used to store individual mutex
#define CM3_MUTEX_SIZE 8
#if CM3_MUTEX_SIZE == 8
typedef u8_t cm3_Mutex;
#endif
#if CM3_MUTEX_SIZE == 16
typedef u16_t cm3_Mutex;
#endif
#if CM3_MUTEX_SIZE == 32
typedef u32_t cm3_Mutex;
#endif

typedef cm3_Mutex ttc_mutex_t;

//}

#endif
