#ifndef cm3_semaphore_types_H
#define cm3_semaphore_types_H

/*{ cm3_semaphore.h ***********************************************
 * 
 * Written by Gregor Rebel 2010-2013
 *
 * Low-level driver for Mutual Exclusive Amounts (Semaphores) on Cortex M3 architecture.
 * 
}*/

//{ includes

#include "ttc_basic.h"

//}includes
//{ Types & Structures ***************************************************

// datatype used to store individual semaphore
#define CM3_SEMAPHORE_SIZE 32
#if CM3_SEMAPHORE_SIZE == 8
typedef u8_t cm3_Semaphore;
#endif
#if CM3_SEMAPHORE_SIZE == 16
typedef u16_t cm3_Semaphore;
#endif
#if CM3_SEMAPHORE_SIZE == 32
typedef u32_t cm3_Semaphore_t;
#endif

typedef cm3_Semaphore_t DRIVER_ttc_semaphore_t;

//}

#endif
