#ifndef heap_freertos_H
#define heap_freertos_H

/*{ heap_freertos.h ************************************************
 
 Thin compatibility layer providing memory allocator of FreeRTOS to ttc_memory
 
}*/
//{ Defines/ TypeDefs ****************************************************


//} Defines
//{ Includes *************************************************************

#include "ttc_basic.h"
#include "ttc_memory_types.h"
#include "FreeRTOS.h"
#include "task.h"
#include "portable.h"

//} Includes
//{ Structures/ Enums ****************************************************

//} Structures/ Enums
//{ driver interface for ttc_memory.h ************************************

#if TTC_MEMORY_STATISTICS == 1
#define DRIVER_ttc_memory_alloc(Size)      heap_freertos_alloc(Size)
#define DRIVER_ttc_memory_free(Block)      heap_freertos_free(Block)
#else
#define DRIVER_ttc_memory_alloc(Size)      pvPortMalloc(Size)
#define DRIVER_ttc_memory_free(Block)      vPortFree(Block) // provided by heap_1.c, heap_2.c, heap_3.c, ...
#endif
#define DRIVER_ttc_memory_get_free_size()  xPortGetFreeHeapSize()

//} Global Variables
//{ Function prototypes **************************************************

/** Initializes memory allocator - Call before using any other function from this source
  *
  * Gets called automatically by extension initializer code
  */
void heap_freertos_init();
void* heap_freertos_alloc(Base_t Size);
void heap_freertos_free(void* Block);

//} Function prototypes

#endif //heap_freertos_H
