/*{ stm32_basic.h ***********************************************
 *
 * TheToolChain.com
 *
 * Written by Gregor Rebel, Sascha Poggemann 2010-2012
 *
 * Basic datatypes, enums and functions additional to cm3_basic.h
 * 
}*/

#include "stm32_basic.h"

void stm32_hardware_init() {

    SystemInit(); // init STM32 standard peripherals library

}
u32_t stm32_get_MCU_Device_ID(){
#ifdef TARGET_ARCHITECTURE_STM32
    return  *(__IO u32_t*)(0xE0042000);
#else
#warning stm32_get_UID not supported for current architecture
#endif
    return 0;
}
void stm32_get_UID (u32_t * Device_Serial0, u32_t * Device_Serial1, u32_t * Device_Serial2){

#ifdef TARGET_ARCHITECTURE_STM32
  #if defined(STM32L1XX_MD) || defined(STM32L1XX_HD) || defined(STM32L1XX_MD_PLUS)
    *Device_Serial0 = *(uint32_t*)(0x1FF80050);
    *Device_Serial1 = *(uint32_t*)(0x1FF80054);
    *Device_Serial2 = *(uint32_t*)(0x1FF80064);
  #else
    *Device_Serial0 = *(__IO u32_t*)(0x1FFFF7E8);
    *Device_Serial1 = *(__IO u32_t*)(0x1FFFF7EC);
    *Device_Serial2 = *(__IO u32_t*)(0x1FFFF7F0);
  #endif /* STM32L1XX_XD */
#else
#warning stm32_get_UID not supported for current architecture
#endif
}
