/*{ cm3_basic.h ***********************************************
 *
 * TheToolChain.com
 *
 * Written by Gregor Rebel, Sascha Poggemann 2010-2012
 *
 * Basic datatypes, enums and functions additional to cm3_basic.h
 * 
}*/

#ifndef STM32_BASIC_H
#define STM32_BASIC_H

//{ includes *************************************************************

#include "cm3_basic.h"
#include "stm32f10x.h"
#include "system_stm32f10x.h"

//} includes *************************************************************
//{ types ****************************************************************
//} types ****************************************************************
//{ includes2 ************************************************************


//} includes2 ************************************************************
//{ Function prototypes **************************************************

/** basic hardware initialization
  */
void stm32_hardware_init();
/** Returns the MCU Device ID
  *
  * @return         the MCU Device ID
  */
u32_t stm32_get_MCU_Device_ID();
/** read the STM32 Unique device ID registers
  *
  * @param u32_t * Device_Serial0  part of the 96bit UID
  * @param u32_t * Device_Serial1  part of the 96bit UID
  * @param u32_t * Device_Serial2  part of the 96bit UID
  */
void stm32_get_UID (u32_t * Device_Serial0, u32_t * Device_Serial1, u32_t * Device_Serial2);
//} Function prototypes **************************************************

#endif
