#ifndef STM32F1_CAN_TYPES_H
#define STM32F1_CAN_TYPES_H

/** { stm32f1_can.h ************************************************
 
                           The ToolChain
                      
   High-Level interface for CAN device.

   Structures, Enums and Defines being required by ttc_can_types.h

   Note: See ttc_can.h for description of stm32f1 independent CAN implementation.
  
   Authors: 

 
}*/
//{ Defines/ TypeDefs ******************************************************


//} Defines
//{ Includes ***************************************************************

#include "../ttc_basic.h"

//} Includes
//{ Structures/ Enums required by ttc_can_types.h ***********************

typedef struct { // register description (adapt according to stm32f1 registers)
  unsigned Reserved1 : 16; 
  unsigned Reserved2 : 16; 
} CAN_Register_t;

typedef struct {  // stm32f1 specific configuration data of single CAN device
  CAN_TypeDef* BaseRegister;       // base address of CAN registers
               u8_t  PhysicalIndex;      // physical device index (1=first CAN device, ...)
} __attribute__((__packed__)) stm32f1_can_config_t;

// ttc_can_arch_t is required by ttc_can_types.h
typedef stm32f1_can_config_t ttc_can_arch_t;

//} Structures/ Enums


#endif //STM32F1_CAN_TYPES_H
