#ifndef ARCHITECTURE_DRIVER_TYPES_H
#define ARCHITECTURE_DRIVER_TYPES_H

/** { architecture_driver.h ************************************************
 
                           The ToolChain
                      
   High-Level interface for DRIVER device.

   Structures, Enums and Defines being required by ttc_driver_types.h

   Note: See ttc_driver.h for description of architecture independent DRIVER implementation.
  
   Authors: 

 
}*/
//{ Defines/ TypeDefs ******************************************************


//} Defines
//{ Includes ***************************************************************

#include "../ttc_basic.h"

//} Includes
//{ Structures/ Enums required by ttc_driver_types.h ***********************

typedef struct { // register description (adapt according to architecture registers)
  unsigned Reserved1 : 16; 
  unsigned Reserved2 : 16; 
} DRIVER_Register_t;

typedef struct {  // architecture specific configuration data of single DRIVER device
  DRIVER_Register_t* BaseRegister;       // base address of DRIVER registers
               u8_t  PhysicalIndex;      // physical device index (1=first DRIVER device, ...)
} __attribute__((__packed__)) architecture_driver_config_t;

// ttc_driver_arch_t is required by ttc_driver_types.h
typedef architecture_driver_config_t ttc_driver_arch_t;

//} Structures/ Enums


#endif //ARCHITECTURE_DRIVER_TYPES_H
