/*{ regression_memory_pools.h ************************************************
 
  Regression test for memory pool driver
  written by Gregor Rebel 2013
 
}*/
#ifndef regression_memory_pools_H
#define regression_memory_pools_H

//{ Includes *************************************************************

#include "ttc_basic.h"
#include "ttc_task.h"
#include "ttc_string.h"
#include "ttc_memory.h"
#include "ttc_gfx.h"
#include "ttc_random.h"
#include "ttc_list.h"
#include "ttc_queue.h"
#include "math_basic.h"

//} Includes
//{ Defines/ TypeDefs ****************************************************

#ifndef EXTENSION_500_ttc_gfx
  #error Missing EXTENSION_500_ttc_gfx !
#endif
#ifdef EXTENSION_500_ttc_memory_heap_sdma
#include "heap_sdma.h"
#endif

//} Defines

typedef struct {
    u8_t X;
    u8_t Y;
    const char* Format;
    Base_t Value;
} printJob_t;

//{ Function prototypes **************************************************

// enqueues print job
void printAt(u8_t X, u8_t Y, const char* Format, u32_t Value);

void taskPrint(void* Arg);

// main entry: initializes hardware + spawns all threads
// returns immediately
void regression_memory_pools_start();

// main task running regression test
void taskRegression_MemoryPools(void* Arg);

//} Function prototypes
#endif //regression_memory_pools_H
