/*{ regression_list.h ************************************************
 
  Regression test for USART communication
  written by Sascha Poggemann 2013
 
}*/

#ifndef regression_USART_H
#define regression_USART_H

/**

Hardwae requirements: You need to connect the USART RX and TX pin.

TTC_USART2_TX=PIN_PD5   # RS232 on 10-pin male header connector TX-Pin
TTC_USART2_RX=PIN_PD6   # RS232 on 10-pin male header connector RX-Pin

This Regression will assert if the received data does not arrive before a timeout
This Regression will assert if the received and transmitted data are different.

**/


//{ Includes *************************************************************

#include "ttc_basic.h"
#include "ttc_task.h"
#include "ttc_string.h"
#include "ttc_memory.h"
#include "ttc_random.h"
#include "ttc_list.h"
#include "ttc_usart.h"

//} Includes
//{ Defines/ TypeDefs ****************************************************

//} Defines

//{ Function prototypes **************************************************

// main entry: initializes hardware + spawns all threads
// returns immediately
void regression_start_usart();
//the main task for this regression
void regression_usart_task(void * pvParameters);
ttc_memory_block_t* reg_usart_receiveData(void* Argument, ttc_usart_generic_t* USART_Generic, ttc_memory_block_t* Data) ;
//} Function prototypes
#endif //regression_USART_H
