
/*{ TemplateName::.c ************************************************

 Empty template for new c-files.
 Copy and adapt to your needs.

}*/

#include "example_can.h"

//{ Global variables *************************************************

ttc_can_config_t*       CAN_Generic;  // architecture independent SPI configuration
ttc_can_filter_config_t* CAN_Filter_Generic;
#define CAN_INDEX 1                   // using first SPI available on current board

//} Global variables
//{ Function definitions *************************************************

void example_can_init() {
#ifdef TTC_LED1
    ttc_gpio_init(TTC_LED1, tgm_output_push_pull);
    ttc_gpio_set(TTC_LED1);
#endif

    u8_t MaxCAN = ttc_can_get_max_index();
    Assert(MaxCAN > 0, ec_UNKNOWN);

    ttc_can_errorcode_e Error;

    CAN_Generic = ttc_can_get_configuration(CAN_INDEX);
    Assert(CAN_Generic, ec_NULL);

    Error = ttc_can_get_features(CAN_Generic);
    Assert(Error == ec_can_OK, ec_UNKNOWN);

    CAN_Generic->CAN_Mode = CAN_LoopBack_Mode;
    CAN_Generic->CAN_TX_Message.CAN_Std_ID = 0xFF;

    ttc_can_init(CAN_INDEX);

//    FilterError = ttc_can_filter_load_defaults(CAN_Filter_Generic);
//    Assert(FilterError == ec_can_OK, ec_UNKNOWN);

//    FilterError = ttc_can_filter_init(CAN_Filter_Generic);
//    Assert(FilterError == ec_can_OK, ec_UNKNOWN);
}

void example_can_start() {
    example_can_init();

    ttc_task_create(task_CAN_sender, // function to start as thread
                    "CANtx",         // thread name (just for debugging)
                    512,             // stack size
                    NULL,            // passed as argument to taskLEDs()
                    1,               // task priority (higher values mean more process time)
                    NULL             // can return a handle to created task
                    );
}

void task_CAN_sender(void *pvParameters) {
    pvParameters = pvParameters; // avoids warning: unused parameter 'pvParameters'

#ifdef TTC_LED1
    ttc_gpio_clr(TTC_LED1);
#endif
    const char* Hello = "1";
    char Buffer[20];
    (void) Buffer;

    while (1) {
#ifdef TTC_LED1
        ttc_gpio_set(TTC_LED1);
        mSleep(3000);
#endif
       ttc_can_send_string(CAN_Generic, Hello, -1);
#ifdef TTC_LED1
        ttc_gpio_clr(TTC_LED1);
#endif
        mSleep(300);
    }
}



//} Function definitions
