#ifndef EXAMPLE_CAN_H
#define EXAMPLE_CAN_H
// Basic set of helper functions
#include "../common/ttc_basic.h"
#include "../common/ttc_can.h"
#include "../common/ttc_gpio.h"

#define USE_STDPERIPH_DRIVER
#include "stm32f10x.h"
#include "core_cm3.h"        // StdPeripheralsLibrary/CMSIS/CM3/CoreSupport/
#include "stm32f10x_conf.h"
#include "bits.h"

#include <string.h>
#include "FreeRTOS.h"
#include "task.h"

//} Includes
//{ Structures/ Enums ****************************************************

//} Structures/ Enums
//{ Global Variables *****************************************************



//} Global Variables
//{ Function prototypes **************************************************

/* Call before example_can_start() to initialize hardware.
 */
void example_can_init();

/* initializes + starts CAN example
 */
void example_can_start();

/* Sends "Hello World" to initialized CAN
 */
void task_CAN_sender(void *pvParameters);

/* Reads from initialized CAN and sends answer
 */
void task_CAN_listener(void *pvParameters);

/* processes received data */
void processData(u8_t* Data, u8_t MaxLength);

//} Function prototypes

#endif // EXAMPLE_CAN_H
