#!/bin/bash
#
#  Install script for ST USB FS Device Library
#  Script written by Sascha Poggemann 2013.
# 
#  Feel free do distribute and change to your own needs!
#
# Tested successfully on: Ubuntu 12.10


source scripts/installFuncs.sh
checkUserRoot "$1" "$2"

StartPath="`pwd`"
INSTALLPATH="400_STM_DFU_Bootloader"
dir "$INSTALLPATH"
cd "$INSTALLPATH"

#{ IMPLEMENT YOUR INSTALL SCRIPT BELOW -----------------------------------------------

DocDir="../../Documentation/STM/USB_FS_Device_Library"

if [ ! -e OK.Documentation ]; then #{
  dir "$Dir"
  #getFile http://www.st.com/internet/com/TECHNICAL_RESOURCES/TECHNICAL_LITERATURE/USER_MANUAL/        CD00289278.pdf UM1021_USB_On-The-Go_host_and_device_library.pdf  $DocDir/                                  || ERROR="1"

  #if [ "$Error" == "" ]; then
   # echo "Documentation complete: $INSTALLPATH."
    touch OK.Documentation

fi #} Documentation
if [ ! -e OK.Install ]; then #{

	DirName="dfu-util"
  
	gitClone 	git://git.openezx.org/dfu-util $DirName
	cd "$DirName" 
	./autogen.sh
	./configure  # on most systems
	make
	#ToDO: We might have to add a uDev Rule to be able to use dfu-util without using sudo 
	# SYSFS{idVendor}=="0483", SYSFS{idProduct}=="df11", MODE="666" GROUP="plugdev" SYMLINK+="usb/stm32_dfu"
	
	cd ..
	touch OK.Install 

fi #} [ ! -e OK.Install ]; then
if [   -e OK.Install ]; then #{

	#create links 
	echo "installed successfully $INSTALLPATH"
#}
else
  echo "failed to install $INSTALLPATH"
  exit 10
fi


#} IMPLEMENT YOUR INSTALL SCRIPT ABOVE -----------------------------------------------

cd "$StartPath"
applyTargetUserAndGroup "$INSTALLPATH"

exit 0
