#!/bin/bash

#
#  Install script for Fixpoint Mathematical Library 
#  URL: http://code.google.com/p/fixpointlib/
#
#  Script written by Gregor Rebel 2010-2011.
# 
#  Feel free do distribute and change to your own needs!
#
# Tested successfully on:
# Ubuntu 10.04 Netbook Edition x86
# KUbuntu 11.04 x86
# openSuSE 11.4 x86
# XUbuntu 11.10 x64

source scripts/installFuncs.sh
checkUserRoot "$1" "$2"

StartPath="`pwd`"
INSTALLPATH="500_ttc_adc"
dir "$INSTALLPATH"
cd "$INSTALLPATH"

#{ IMPLEMENT YOUR INSTALL SCRIPT BELOW -----------------------------------------------

  Name="$INSTALLPATH"
  createExtensionSourcefileHead ${Name}    #{ (create initializer code)

  # Below you may write C-code that will automatically being placed inside extensions.active/ttc_extensions_active.c during _/compile.sh
  # Every #include directive will automatically being added to extensions.active/ttc_extensions_active.h
  #
  cat <<END_OF_SOURCEFILE >>$ExtensionSourceFile

  #include "ttc_adc.h"


END_OF_SOURCEFILE
  createExtensionSourcefileTail ${Name} #}
  createExtensionMakefileHead ${Name}      #{ create makefile
  cat <<END_OF_MAKEFILE >>$ExtensionMakeFile # variable set by createExtensionMakefileHead()

# Check for used architecture and activate .o file
ifdef TARGET_ARCHITECTURE_STM32
  MAIN_OBJS += stm32_adc.o
endif

ifdef EXTENSION_200_cpu_stm32f10x
  MAIN_OBJS += stm32f10x_dma.o
endif
  
  MAIN_OBJS += ttc_adc.o

END_OF_MAKEFILE
  createExtensionMakefileTail ${Name} #}
  createActivateScriptHead $Name ../extensions/ $0 "architecture independent support of Analog Digital Converters (ToDo: INCOMPLETE)" #{ 
  
  # create links into extensions.active/
  cat <<END_OF_ACTIVATE >>$ActivateScriptFile
  
createLink \$Dir_Extensions/makefile.$Name \$Dir_ExtensionsActive/makefile.$Name '' QUIET

activate.250_stm_std_peripherals__adc.sh QUIET \"\$0\"

END_OF_ACTIVATE
  
  createActivateScriptTail $Name ../extensions/
  #}

#}

  echo "Installed successfully: $INSTALLPATH"

cd ..
#} IMPLEMENT YOUR INSTALL SCRIPT ABOVE -----------------------------------------------

cd "$StartPath"
applyTargetUserAndGroup "$INSTALLPATH"

exit 0
