#!/bin/bash

Binary="$1"
if [ "$Binary" == "" ]; then
  Binary="main.bin"
fi
if [ ! -e "$Binary" ]; then
  echo "$0 BINARY"
  echo "  ERROR: Cannot find binary $Binary!"
  exit 5
fi

# ensure that no other openocd is currently connected
pkill -9 openocd && {
    echo "$0 - openocd was running: killing it"
    sleep 0.2 # short delay, for SIGKILL signal to be processed
}

if [ -x target_flash.sh ]; then # using project specific flash script
  source target_flash.sh
else                            # using default openocd flash script
  source _/openocd_flash.sh $Binary
fi
if [ "$Error" == "" ]; then
  echo "Successfully flashed"
else
  exit 10
fi

